<!DOCTYPE html>

<html lang="en">

<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>Task 68</title>

    <!-- Google Font: Source Sans Pro -->
    <link rel="stylesheet"
        href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
    <!-- Font Awesome Icons -->
    <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
    <!-- Theme style -->
    <link rel="stylesheet" href="dist/css/adminlte.min.css">
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.4.0/css/all.min.css">
</head>

<body class="hold-transition sidebar-mini">

    <div class="wrapper">
        <!-- Navbar -->
        <nav class="main-header navbar navbar-expand navbar-white navbar-light">
            <!-- Left navbar links -->
            <ul class="navbar-nav">
                <li class="nav-item">
                    <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
                </li>
                <li class="nav-item d-none d-sm-inline-block">
                    <a href="#" class="nav-link">Home</a>
                </li>
            </ul>
        </nav>
        <!-- /.navbar -->
        <!-- Main Sidebar Container -->
        <aside class="main-sidebar sidebar-dark-primary elevation-4">
            <!-- Brand Logo -->
            <a href="#" class="brand-link">
                <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3"
                    style="opacity: .8">
                <span class="brand-text font-weight-light">Devcamp 120</span>
            </a>

            <!-- Sidebar -->
            <div class="sidebar">
                <!-- Sidebar user panel (optional) -->
                <div class="user-panel mt-3 pb-3 mb-3 d-flex">
                    <div class="image">
                        <img src="dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="User Image">
                    </div>
                    <div class="info">
                        <a href="#" class="d-block">Hồ Bá TRường</a>
                    </div>
                </div>


                <!-- Sidebar Menu -->
                <nav class="mt-2">
                    <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu"
                        data-accordion="false">
                        <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
                        <li class="nav-item menu-open">
                            <a href="User.html" class="nav-link">
                                <i class="nav-icon fas fa-tachometer-alt"></i>
                                <p>
                                    Quay về User
                                    <i class="right fas fa-angle-left"></i>
                                </p>
                            </a>
                        </li>
                        <li class="nav-item">
                            <a href="Order.html" class="nav-link active">
                                <i class="far fa-circle nav-icon"></i>
                                <p>
                                    Order list
                                </p>
                            </a>
                        </li>
                    </ul>
                </nav>
                <!-- /.sidebar-menu -->
            </div>
            <!-- /.sidebar -->
        </aside>
        <div class="content-wrapper">
            <!-- Content Header (Page header) -->
            <div class="content-header">
                <div class="container-fluid">
                    <div class="row mb-2">
                        <div class="col-sm-6">
                            <h2>DANH SÁCH ORDER</h2>
                        </div><!-- /.col -->
                        <div class="col-sm-6">
                            <ol class="breadcrumb float-sm-right">
                                <li class="breadcrumb-item"><a href="#">Home</a></li>
                                <li class="breadcrumb-item active">Order list</li>
                            </ol>
                        </div><!-- /.col -->
                    </div><!-- /.row -->
                </div><!-- /.container-fluid -->
            </div>
            <!-- /.content-header -->

            <!-- Main content -->
            <div class="content">
                <div class="container-fluid">
                    <div class="row">
                        <button class="btn btn-primary" id="btn-create"><i class="fa-solid fa-plus"></i> &nbsp; Create
                            Order</button>
                        <div class="col-12">
                            <table class="table table-bordered table-striped table-hover" id="order-table">
                                <thead>
                                    <tr>
                                        <th>ID</th>
                                        <th>Mã Order</th>
                                        <th>Pizza Size</th>
                                        <th>Pizza Type</th>
                                        <th>Mã Voucher</th>
                                        <th>Price</th>
                                        <th>Paid</th>
                                        <th>Ngày tạo</th>
                                        <th>Ngày cập nhật</th>
                                        <th>Action</th>
                                    </tr>
                            </table>
                            <!-- Vùng Modal -->
                            <!-- Create Order modal -->
                            <div>
                                <div id="create-order-modal" class="modal fade" tabindex="-1">
                                    <div class="modal-dialog">
                                        <div class="modal-content">
                                            <div class="modal-header">
                                                <h5 class="modal-title" id="h5-modal-title">Create Order
                                                </h5>
                                                <button class="close" data-dismiss="modal">&times;</button>
                                            </div>
                                            <div class="modal-body">
                                                <form>
                                                    <div class="row form-group">
                                                        <div class="col-sm-3">
                                                            <label>Mã Order</label>
                                                        </div>
                                                        <div class="col-sm-9">
                                                            <input type="text" id="input-create-orderCode"
                                                                class="form-control">
                                                        </div>
                                                    </div>
                                                    <div class="row form-group">
                                                        <div class="col-sm-3">
                                                            <label>Pizza Size</label>
                                                        </div>
                                                        <div class="col-sm-9">
                                                            <input type="text" id="input-create-pizzaSize"
                                                                class="form-control">
                                                        </div>
                                                    </div>
                                                    <div class="row form-group">
                                                        <div class="col-sm-3">
                                                            <label>Pizza Type</label>
                                                        </div>
                                                        <div class="col-sm-9">
                                                            <input type="text" id="input-create-pizzaType"
                                                                class="form-control">
                                                        </div>
                                                    </div>
                                                    <div class="row form-group">
                                                        <div class="col-sm-3">
                                                            <label>Mã Voucher</label>
                                                        </div>
                                                        <div class="col-sm-9">
                                                            <input type="text" id="input-create-voucherCode"
                                                                class="form-control">
                                                        </div>
                                                    </div>
                                                    <div class="row form-group">
                                                        <div class="col-sm-3">
                                                            <label>Price</label>
                                                        </div>
                                                        <div class="col-sm-9">
                                                            <input type="number" id="input-create-price"
                                                                class="form-control">
                                                        </div>
                                                    </div>
                                                    <div class="row form-group">
                                                        <div class="col-sm-3">
                                                            <label>Paid</label>
                                                        </div>
                                                        <div class="col-sm-9">
                                                            <input type="number" id="input-create-paid"
                                                                class="form-control">
                                                        </div>
                                                    </div>
                                                </form>
                                            </div>
                                            <div class="modal-footer">
                                                <button class="btn btn-secondary" id="btn-create-cancel"
                                                    data-dismiss="modal">Cancel</button>
                                                <button class="btn btn-primary" id="btn-create-order">Create
                                                    order</button>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>

                            <!-- Update Order modal -->
                            <div>
                                <div id="update-order-modal" class="modal fade" tabindex="-1">
                                    <div class="modal-dialog">
                                        <div class="modal-content">
                                            <div class="modal-header">
                                                <h5 class="modal-title" id="h5-modal-title">Update Trạng Thái order
                                                </h5>
                                                <button class="close" data-dismiss="modal">&times;</button>
                                            </div>
                                            <div class="modal-body">
                                                <form>
                                                    <div class="row form-group">
                                                        <div class="col-sm-3">
                                                            <label>Mã Order</label>
                                                        </div>
                                                        <div class="col-sm-9">
                                                            <input type="text" id="input-update-orderCode"
                                                                class="form-control">
                                                        </div>
                                                    </div>
                                                    <div class="row form-group">
                                                        <div class="col-sm-3">
                                                            <label>Pizza Size</label>
                                                        </div>
                                                        <div class="col-sm-9">
                                                            <input type="text" id="input-update-pizzaSize"
                                                                class="form-control">
                                                        </div>
                                                    </div>
                                                    <div class="row form-group">
                                                        <div class="col-sm-3">
                                                            <label>Pizza Type</label>
                                                        </div>
                                                        <div class="col-sm-9">
                                                            <input type="text" id="input-update-pizzaType"
                                                                class="form-control">
                                                        </div>
                                                    </div>
                                                    <div class="row form-group">
                                                        <div class="col-sm-3">
                                                            <label>Mã Voucher</label>
                                                        </div>
                                                        <div class="col-sm-9">
                                                            <input type="text" id="input-update-voucherCode"
                                                                class="form-control">
                                                        </div>
                                                    </div>
                                                    <div class="row form-group">
                                                        <div class="col-sm-3">
                                                            <label>Price</label>
                                                        </div>
                                                        <div class="col-sm-9">
                                                            <input type="number" id="input-update-price"
                                                                class="form-control">
                                                        </div>
                                                    </div>
                                                    <div class="row form-group">
                                                        <div class="col-sm-3">
                                                            <label>Paid</label>
                                                        </div>
                                                        <div class="col-sm-9">
                                                            <input type="number" id="input-update-paid"
                                                                class="form-control">
                                                        </div>
                                                    </div>
                                                </form>
                                            </div>
                                            <div class="modal-footer">
                                                <button class="btn btn-secondary" id="btn-update-cancel"
                                                    data-dismiss="modal">Cancel</button>
                                                <button class="btn btn-primary" id="btn-update-order">Update Trạng
                                                    Thái</button>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>

                            <!-- Delete confirm modal -->
                            <div>
                                <div class="modal fade" tabindex="-1" id="delete-confirm-modal">
                                    <div class="modal-dialog">
                                        <div class="modal-content">
                                            <div class="modal-header">
                                                <h5 class="modal-title" id="h5-modal-title">Order Delete Confirmation
                                                </h5>
                                                <button class="close" data-dismiss="modal">&times;</button>
                                            </div>
                                            <div class="modal-body">
                                                <label>Bạn có chắc chắn muốn xóa order này không?</label>
                                            </div>
                                            <div class="modal-footer">
                                                <button class="btn btn-danger"
                                                    id="btn-confirm-delete-order">Confirm</button>
                                                <button class="btn btn-secondary" data-dismiss="modal">Cancel</button>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                            <!-- Order Detail modal -->
                            <div>

                            </div>
                        </div>
                    </div>
                    <!-- /.row -->
                </div><!-- /.container-fluid -->
            </div>
            <!-- /.content -->
        </div>
        <!-- Main Footer -->
        <footer class="main-footer">
            <!-- To the right -->
            <div class="float-right d-none d-sm-inline">
                DANH SÁCH ĐƠN HÀNG
            </div>
            <!-- Default to the left -->
            <strong>Copyright &copy; 2023 Devcamp 120.</strong> All rights
            reserved.
        </footer>
    </div>
    <!-- jQuery -->
    <script src="plugins/jquery/jquery.min.js"></script>
    <!-- Bootstrap 4 -->
    <script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
    <!-- AdminLTE App -->
    <script src="dist/js/adminlte.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
    <script>
        "use strict";
        $(document).ready(function () {
            /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
            const gBASE_URL = "http://localhost:8080/order/";

            const gCOLUMN_ID = 0;
            const gCOLUMN_ORDER_CODE = 1;
            const gCOLUMN_PIZZA_SIZE = 2;
            const gCOLUMN_PIZZA_TYPE = 3;
            const gCOLUMN_VOUCHER_CODE = 4;
            const gCOLUMN_PRICE = 5;
            const gCOLUMN_PAID = 6;
            const gCOLUMN_NGAY_TAO = 7;
            const gCOLUMN_NGAY_CAP_NHAT = 8;
            const gCOLUMN_ACTION = 9;

            const gCOLUMN = ["id", "orderCode", "pizzaSize", "pizzaType", "voucherCode", "price", "paid", "created", "updated", "action"];

            var gOrder_code = {
                id: "",
            }
            // định nghĩa table  - chưa có data
            var gorderTable = $("#order-table").DataTable({
                // Khai báo các cột của datatable
                "columns": [
                    { "data": gCOLUMN[gCOLUMN_ID] },
                    { "data": gCOLUMN[gCOLUMN_ORDER_CODE] },
                    { "data": gCOLUMN[gCOLUMN_PIZZA_SIZE] },
                    { "data": gCOLUMN[gCOLUMN_PIZZA_TYPE] },
                    { "data": gCOLUMN[gCOLUMN_VOUCHER_CODE] },
                    { "data": gCOLUMN[gCOLUMN_PRICE] },
                    { "data": gCOLUMN[gCOLUMN_PAID] },
                    { "data": gCOLUMN[gCOLUMN_NGAY_TAO] },
                    { "data": gCOLUMN[gCOLUMN_NGAY_CAP_NHAT] },
                    { "data": gCOLUMN[gCOLUMN_ACTION] }
                ],
                // Ghi đè nội dung của cột action, chuyển thành button chi tiết
                "columnDefs": [
                    {
                        "targets": gCOLUMN_ACTION,
                        "defaultContent": '<i class="fas fa-pen text-info edit-order"></i> &nbsp &nbsp &nbsp <i class="fas fa-trash text-danger delete-order"></i>'
                    }]
            });

            /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
            onPageLoading();
            $("#btn-create").on("click", function () {
                $("#create-order-modal").modal("show");
            });
            $("#btn-create-order").on("click", function () {
                onCreateorder();
            });
            $("#order-table").on("click", ".edit-order", function () {
                onButtonChiTietClick(this); // this là button được ấn
            });
            // khi ấn nút sự kiện update trên modal
            $("#btn-update-order").on("click", function () {
                onBtnUpdateClick();
            });
            // khi ấn sự kiện delete
            $("#order-table").on("click", ".delete-order", function () {
                onBtnDeleteConfirmOrderClick(this);
            });
            // gán sự kiện cho nút Delete  (trên modal)
            $("#btn-confirm-delete-order").on("click", function () {
                onBtnDeleteorderClick();
            });
            /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
            // Hàm sự kiện thêm order
            function onCreateorder() {
                // khai báo dữ liệu
                var vorderObj = {
                    orderCode: "",
                    pizzaSize: "",
                    pizzaType: "",
                    voucherCode: "",
                    price: 0,
                    paid: 0
                }
                // thu thập thông tin 
                getCreateData(vorderObj);
                // validate
                if (kiemtraCreateData(vorderObj)) {
                    // Tạo mới order
                    createOrder(vorderObj);
                }
            }
            // hàm thu thập thông tin để create order
            function getCreateData(paramObj) {
                paramObj.orderCode = $("#input-create-orderCode").val();
                paramObj.pizzaSize = $("#input-create-pizzaSize").val();
                paramObj.pizzaType = $("#input-create-pizzaType").val();
                paramObj.voucherCode = $("#input-create-voucherCode").val();
                paramObj.price = $("#input-create-price").val();
                paramObj.paid = $("#input-create-paid").val();
            }
            function kiemtraCreateData(paramObj) {
                if (paramObj.orderCode == "") {
                    alert("Bạn điền mã order không hợp lệ")
                    return false;
                }
                if (paramObj.pizzaSize == "") {
                    alert("Bạn điền pizza size không hợp lệ")
                    return false;
                }
                if (paramObj.pizzaType == 0) {
                    alert("Bạn điền pizza type không hợp lệ")
                    return false;
                }
                if (paramObj.voucherCode == "") {
                    alert("Bạn điền mã voucher không hợp lệ")
                    return false;
                }
                if (paramObj.price == 0) {
                    alert("Bạn điền price không hợp lệ")
                    return false;
                }
                if (paramObj.paid == 0) {
                    alert("Bạn điền paid không hợp lệ")
                    return false;
                }
                return true;
            }
            //Hàm tạo đơn mói
            function createOrder(paramObj) {
                var vUrlString = window.location.href; //đường đẫn gọi đến trang
                var vUrl = new URL(vUrlString);
                var vID = vUrl.searchParams.get("id");
                $.ajax({
                    url: gBASE_URL + "create/" + vID,
                    type: 'POST',
                    data: JSON.stringify(paramObj),
                    contentType: "application/json; charset=utf-8",
                    dataType: 'json',
                    success: function (paramObjorder) {
                        //hiển thị dữ liệu lên web
                        console.log(paramObjorder);
                        onPageLoading();
                        $("#create-order-modal").modal("hide");
                        alert("Bạn tạo thành công order");
                        $("#input-create-orderCode").val("");
                        $("#input-create-pizzaSize").val("");
                        $("#input-create-pizzaType").val("");
                        $("#input-create-voucherCode").val("");
                        $("#input-create-price").val("");
                        $("#input-create-paid").val("");
                    },
                    error: function (error) {
                        alert("Bạn tạo order thất bại!");
                        console.log(error.responseText)
                    }
                });
            }
            // infoFunction sẽ là function các nút cùng gọi
            function onButtonChiTietClick(paramChiTietButton) {
                //Xác định thẻ tr là cha của nút được chọn
                var vRowSelected = $(paramChiTietButton).parents('tr');
                //Lấy datatable row
                var vDatatableRow = gorderTable.row(vRowSelected);
                //Lấy data của dòng 
                var vorderData = vDatatableRow.data();
                gOrder_code.id = vorderData.id;
                // lấy api để load vào modal
                getorderbyorderID();
                $("#update-order-modal").modal("show");
            }
            function getorderbyorderID() {
                $.ajax({
                    url: "http://localhost:8080/order/details/" + gOrder_code.id,
                    type: "GET",
                    dataType: 'json',
                    success: function (responseObject) {
                        //debugger;
                        loadDataToModal(responseObject);
                    },
                    error: function (error) {
                        console.assert(error.responseText);
                    }
                });
            }
            // hàm load data to modal update
            function loadDataToModal(paramResponseObject) {
                $("#input-update-orderCode").val(paramResponseObject.orderCode);
                $("#input-update-pizzaSize").val(paramResponseObject.pizzaSize);
                $("#input-update-pizzaType").val(paramResponseObject.pizzaType);
                $("#input-update-voucherCode").val(paramResponseObject.voucherCode);
                $("#input-update-price").val(paramResponseObject.price);
                $("#input-update-paid").val(paramResponseObject.paid);
            }
            function onPageLoading() {

                //Khai báo dữ liệu
                //validate
                // lấy data từ server
                getAllorderbyapi();
                // Xử lý front-end
            }

            /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình */
            function getAllorderbyapi() {
                //gán dữ liệu
                var vUrlString = window.location.href; //đường đẫn gọi đến trang
                var vUrl = new URL(vUrlString);
                var vID = vUrl.searchParams.get("id");
                var vValid = kiemtraID(vID);
                if (vValid) {
                    $.ajax({
                        url: "http://localhost:8080/user/"+ vID +"/orders",
                        type: "GET",
                        dataType: 'json',
                        success: function (responseObject) {
                            //debugger;
                            loadDataToTable(responseObject);
                        },
                        error: function (error) {
                            console.assert(error.responseText);
                            window.location.href = "User.html";
                        }
                    });
                }
            }
            //hàm kiểm tra ID
            function kiemtraID(paramID) {
                if (paramID == null || paramID == "") {
                    alert("QueryString không có ID");
                    window.location.href = "User.html";
                    return false;
                }
                return true;
            }
            // load data to table
            function loadDataToTable(paramResponseObject) {
                //Xóa toàn bộ dữ liệu đang có của bảng
                gorderTable.clear();
                //Cập nhật data cho bảng 
                gorderTable.rows.add(paramResponseObject);
                //Cập nhật lại giao diện hiển thị bảng
                gorderTable.draw();
            }
            // khi bấm nút Update trên modal
            function onBtnUpdateClick() {
                console.log(gOrder_code.id);
                //khai báo dữ liệu
                var vObjectRequest = {
                    orderCode: "",
                    pizzaSize: "",
                    pizzaType: "",
                    voucherCode: "",
                    price: 0,
                    paid: 0
                }
                // gán dữ liệu
                vObjectRequest.orderCode = $("#input-update-orderCode").val();
                vObjectRequest.pizzaSize = $("#input-update-pizzaSize").val();
                vObjectRequest.pizzaType = $("#input-update-pizzaType").val();
                vObjectRequest.voucherCode = $("#input-update-voucherCode").val();
                vObjectRequest.price = $("#input-update-price").val();
                vObjectRequest.paid = $("#input-update-paid").val();
                //validate
                var validate = kiemtraCreateData(vObjectRequest);
                if (validate) {
                    //cập nhật trạng thái
                    updateOrder(vObjectRequest);
                }
            }
            //update order
            function updateOrder(paramObj) {
                $.ajax({
                    url: gBASE_URL + "update/" + gOrder_code.id,
                    type: "PUT",
                    data: JSON.stringify(paramObj),
                    contentType: "application/json; charset=utf-8",
                    dataType: 'json',
                    success: function (responseObject) {
                        //debugger;
                        handleUpdatetSuccess(responseObject.id);
                    },
                    error: function (error) {
                        console.assert(error.responseText);
                    }
                });
            }
            // hàm xử lý sự kiện delete order modal click
            function onBtnDeleteorderClick() {
                //khai báo dữ liệu
                //validate
                //gọi api
                $.ajax({
                    url: gBASE_URL + "delete/" + gOrder_code.id,
                    type: "DELETE",
                    contentType: "application/json; charset=utf-8",
                    success: function (paramRes) {
                        // B4: xử lý front-end
                        handleDeleteorderSuccess();
                    },
                    error: function (paramErr) {
                        console.log(paramErr.status);
                    }
                });
                //hiển thị thông tin
            }
            // hàm xử lý hiển thị front-end khi update Trạng thái thành công
            function handleUpdatetSuccess(paramObj) {
                onPageLoading();
                alert("Update order Id = " + paramObj + " thành công!");
                $("#update-order-modal").modal("hide");
            }
            // hàm xử lý hiển thị front-end khi sửa order thành công
            function handleDeleteorderSuccess() {
                onPageLoading();
                alert("Xóa order thành công!");
                $("#delete-confirm-modal").modal("hide");
            }
            function onBtnDeleteConfirmOrderClick(paramChiTietButton) {
                //Xác định thẻ tr là cha của nút được chọn
                var vRowSelected = $(paramChiTietButton).parents('tr');
                //Lấy datatable row
                var vDatatableRow = gorderTable.row(vRowSelected);
                //Lấy data của dòng 
                var vorderData = vDatatableRow.data();
                gOrder_code.id = vorderData.id;
                // lấy api để load vào modal
                $("#delete-confirm-modal").modal("show");
            }
        });
    </script>
</body>

</html>